#ifndef ASPECT_LIB_H
#define ASPECT_LIB_H

#include "aspectStruct.h"

int aspectMapFillIn(ASPECT_CONFIG *sensorViewPoint, 
		    ASPECT_VIEW_PARAMETERS *viewParameters,
		    int nbInputMapSegs, 
		    const ASPECT_SEG cartMap[],
		    int outputCartInGlobalFrameFlag,
		    int aspectOutputTabSize,
		    ASPECT_SEG aspectCartToFill[],
		    ASPECT_POLAR_SEG aspectPolarToFill[],
		    int inputSegId[],
		    double angleStep,
		    double *rho);

int aspectMapAlloc(ASPECT_CONFIG *sensorViewPoint, 
		   ASPECT_VIEW_PARAMETERS *viewParameters,
		   int nbInputMapSegs, 
		   const ASPECT_SEG cartMap[],
		   int outputCartInGlobalFrameFlag,
		   ASPECT_SEG **aspectCartToAlloc,
		   ASPECT_POLAR_SEG **aspectPolarToAlloc,
		   int **inputSegId,
		   double angleStep,
		   double *rho);

int aspectSimulLaser(double thMin, double thMax, double dth, 
		     int nbSegs,
		     ASPECT_POLAR_SEG polar[], ASPECT_SEG *cartLocal, 
		     int nbEchos, double *rho);

double aspectDistToSeg (ASPECT_SEG *seg);

int 
aspectComputesAspect(ASPECT_CONFIG *sensorViewPoint, 
		     ASPECT_VIEW_PARAMETERS *viewParameters,
		     int nbInputMapSegs, 
		     const ASPECT_SEG cartMap[],
		     int outputCartInGlobalFrameFlag,
		     int aspectOutputTabSize,
		     ASPECT_SEG aspectCartToFill[],
		     ASPECT_POLAR_SEG aspectPolarToFill[],
		     int inputSegsIdToFill[],
		     ASPECT_SEG **aspectCartToAlloc,
		     ASPECT_POLAR_SEG **aspectPolarToAlloc,
		     int **inputSegIdToAlloc,
		     double angleStep,
		     double *rho);

ASPECT_SEG * 
aspectReadSegkitMap(char *filename, int *nbsegs);

int aspectClipPolarSeg(double minAngleView, double maxAngleView, 
		       double maxDistView,
		       ASPECT_POLAR_SEG *polar,
		       ASPECT_SEG *cartSeg);

int aspectCartToPolarFilter(ASPECT_SEG *cartSeg, 
			    ASPECT_POLAR_SEG *polarSeg,
			    double maxDistView, 
			    int filterAngleView,
			    double minAngleView,
			    double maxAngleView,
			    int *reverted);

#endif
