/*----------------------------------------------------------------------
 *
 * Map_builder_private_p.h
 *
 * PRIVATE functions of Map_builder.c
 * Do not use this file
 * External functions are in User.h and Map_builder_p.h
 *
 */
#ifndef _MAP_BUILDER_PROVATE_H
#define _MAP_BUILDER_PRIVATE_H

static void TreatData(long data, laserConfiguration *sick_config);

/****** 
  Appends the new data "data" to the map using the set of 
  matchings in lsm and the robot position (xp) plus its variance
  (vxp)
****/


static void Append2Map(long data,PDBL *lsm,double *xp, double *vxp);

/*************
  computes in sg1 the union of sg1 - sg2 which are supposed
  "matched". Takes the maximum extension 
  of the overlapping
**************/

static void Maximum_length_seg(Sgl *sg1,Sgl *sg2,double *test);


/***
  tries to merge segments in the map itself in case they've been
  forgotten by the localization process.
  Computes intersections
***/

static void AutoFusion(void);


static void free_matchings(PDBL *lm);

/*** Filtering function. the function "filter" can be anything returning
     1 if you want to filter out the segment s considered ***/


static void FilterOut(igla *image,long (*filter)(Sgl *s));

/** 
  returns 1 if the extremity points of the segment s 
  define a cone of less than DATA_ANG 
**/
  
static long FilterData(Sgl *s);



static int OkIntersectionF(Sgl *s1,Sgl *s2);

#endif /* _MAP_BUILDER_PRIVATE_H */

