#ifndef MAP_MGR_H
#define MAP_MGR_H

#include "lasers_robots.h"

/* >>>> The following functions are also in User.h */

void Init_map(void);
long  Global_localization(long,long *,long,int);
long  Local_localization(long,double,double,long *,long,int, 
			 laserConfiguration *sick_config);
void NewSegment(double,double,double,double);
void ReadMap(char *file);
void Set_map_unaccuracy(double);
void NewSegmentBound(double x1,double y1,double x2,double y2);
void Init_boundary(void);
void CloseMap(void);

/* <<<<< The previous functions are also in User.h */

void LocFilterOn(void);
void LocFilterOff(void);
void MergeOdoOn(void);
void MergeOdoOff(void);

/*****
 SetRelocThres : 
 *****/

void SetRelocThres(long);


/******
  added 05/11/94: functions for interfacing with
  the map builder: 
  When the map is driven from outside, one must be careful not to forget
  to create an auxilliary structure "Local_map" using the function
  "Imgl_create_copy" defined in las_struct.c 
  This structure will be used by the localization function.
  I will add a function "Rinit_map" which reallocate and free (if necessary)
  this auxilliary structure. 
  
  For now, do
  

  if needed do 
  FreeLocalMap();
  SetMap(extern_map);
  extern_local_map = Imgl_create_copy(extern_map);
  SetLocalMap(extern_local_map);

**********************************/


/**********************  
  added 05/11/94: 
  set the current map from the builder;
******/

void SetMap(long map);

/**** 
  added 05/11/94 : setting Local_map to the auxilliary structure
  defined by a external user
****/

void SetLocalMap(igla *loc_aux); 

/****
  added 05/11/94: freeing the auxilliary structure used for
  the computation of the aspect and the disambiguating.
****/

void FreeLocalMap(void);

/*** 
  added 05/10/94 : function for accessing the map from
  outside the Map Manager.
****/

long Get_map_num(void);

/*** 
  added 05/21/94 : function for accessing the aspect from
  outside the Map Manager.
****/

long Get_aspect_num(void);

void SetBoundary(long bound);

long ReadBuiltMap(const char *file);

void SaveMap();

long SaveMapToFile(const char *file);

long GetPositionArray(long *pos, int maxtabsize);


long GetNSuccess ();

long GetNpossibilities ();

void UnsetMap(void);

PDBL *GetListValidHypo();

void segkitSetAspectDistMax(double distmax);


void segkitGetAspectDistMax(double *distmax);


#endif /* MAP_MGR_H */

