#ifndef _match_p
#define _match_p



/** 
  apply ComputeFinalLocation to the list of
  hypothesis lhyp 
**/

void ComputeFinalListHypo(PDBL *lhyp);


int Init_Matching(igla *, igla *,igla *);
    
/*****
  building a pre-hypothesis list of possible 
  matchings; 
  Each element of the list is composed of a list 
  of matching which are compatible in angle;
*****/


PDBL *Angular_group(igla *igp,igla *igm);
  
  
void Free_list_hyp(PDBL *);
  
void SetMinLength(double);  


/****************
  computes all possible hypothesis 
  from the list of pre-hypothesis 
  lphyp

  Building of the list Lhypo

***************/

PDBL *Gen_Exp_Lhyp(PDBL *lphyp);
     



PDBL *test_validity_hypos(igla *ig1,igla *ig2, igla *bound,
			 PDBL *phyp,long op,long thres,double distmax);

long hypo_is_valid(igla *igp,igla *igm,double thr);

void Expurge_multiplicity(PDBL *);

/****
  setting the peed level; roughly it goes like this:
  level 0 : 
      slowest pace; at each step of the algorithm a probabilistic test
      is used as well as a kalman filtering for estimating the location
      of each hypothesis
  level 1 :
      the matching test is now heuristic only. The estimation are still 
      computed with kalman filtering all the way.
  level 2 : 
      only the initial position of each hypothesis is using probabilitic
      computation. Subsequent matches are only integrated in the list of
      matches but don't contribute to the location estimation.
      However, at the end, the feasible locations (and
      only them) will be plainly computed using the entire list of matches.
  level 3: the fastest. Doesn't use any probabilitic computation
      for initializing nor updating the locations, At the end we still
      compute plainly all feasible hypothesis such that the output is both
      more accurate and suitable for map building purposes.
****/ 
  
void SetSpeedLevel(int n);

void Set_loc_angle(double,double);
int Get_loc_angle(double *mean, double *gap);

void Unset_loc_angle(void);

#endif /* _match_p */

  
  












