#ifndef _match_private_p
#define _match_private_p

/* ----------------------------------------------------------------------
   PROTOTYPE OF PRIVATE FUNCTIONS OF match.c
   ---------------------------------------------------------------------- */

/**** 
  In case the speed level is high we didn't compute
  very accurately the location corresponding to 
  each hypothesis. The variances are not
  computed yet either. However, in each hypothesis
  structure, there is a list of matchings (hyp->lsm)
  from which this can be done. This is the purpose
  of this function.
****/

static void ComputeFinalLocation(Hyp *hyp);


/*** 
   array manager for matchings for ensuring not generating too
  much hypothesis
***/

static void set_array_prehyp(Prehyp *phyp);

static void Fill_array_prehyp(PDBL *lsm);

static long Cree_list_match(igla *igp,igla *igm);
  
static long Ang_match(igla *igp,igla *igm);

static long test_ang_mct(Smatch *mct,PDBL *l);
  
static long test_between(Prehyp *m1,Prehyp *m2,Smatch *mct);

static void Fill_match(Smatch *mct,Sgl *sp,Sgl *sm);
  
static PDBL * Add_Phyp(PDBL *hyp,Smatch *mct);
 



/*************************
  computes all possible hypothesis from 
  the pre-hypothesis in l (l is the list pointer
  on the actual pre-hypothesis)
*************************/
    
static void Gen_Expand(PDBL *l);
    
static void Expand(Smatch *m1,Smatch *m2,double *xp,double *vp,double *vtest,PDBL *lmatch,Hyp *hyp,long op);


static void HypExpand(Smatch *m1,Smatch *m2,double *tr,double *vt,PDBL *phyp,Hyp *hyp,long width);
   

#ifdef UNUSED
static long Well_defined_hypo(Hyp *);
#endif /* UNUSED */
  
/************************
  Function for reducing the perceptual data used for 
  localizing; 

  Case dynamic: SelectAll -> no assumption is made that any data 
			     the environment
*************************/







/**************
selecting two "good" segments (long and with a good angle)
for localizing
**************/


       


static long SelectionPercepts(igla *igp);
    



static void angle_reliability_order(igla *igp);

static long test_unacuracy(Sgl *s1,Sgl *s2);

#ifdef UNUSED
static Hyp *choose_best_hypo(PDBL *);
#endif /* UNUSED */

static long Hypo_generated(Smatch *m1,Smatch *m2);

#endif /* _match_private_p */

  
  












